Subject: Re: [PATCH] netfilter: nf_nat: avoid double nat for loopback

From: Patrick McHardy <[email-masked]>
Date: Tue, 07 Jun 2011 11:37:43 +0200

On 04.06.2011 16:02, Julian Anastasov wrote:
> 
> 	Avoid double NAT and seq adjustment for loopback
> traffic because it causes silent repetition of TCP data. One
> example is passive FTP with DNAT rule and difference in the
> length of IP addresses.
> 
> 	This patch adds checks if packet is sent and
> received via loopback device. As the same conntrack is used
> both for outgoing and incoming direction, we restrict NAT,
> seq adjustment and confirmation to happen only in
> outgoing direction (OUTPUT and POSTROUTING).
> 
> Signed-off-by: Julian Anastasov <[email-masked]>
> ---
> 
> 	As the check is not so cheap, another alternative
> is to add new skb flag, eg. "loopback", that can be set in 
> drivers/net/loopback.c, loopback_xmit(). May be there is space
> for it in flags2?

I don't think we should be adding code specifically needed for netfilter
to the loopback driver if we can avoid it. I don't think we need to
actually avoid calling nf_nat_packet twice, that shouldn't do any harm,
just the sequence number adjustment. So we could add the loopback check
to the IPS_SEQ_ADJUST_BIT case to at least avoid it in some cases.
Would that work or am I missing something?